import java.sql.*; 

public class PreparedStatementEx{ 
	static{ 
		try{ 
			Class.forName("oracle.jdbc.driver.OracleDriver"); 
		}catch(ClassNotFoundException cnfe){ 
			cnfe.printStackTrace(); 
		} 
	} 
	public static void main(String arg[]){ 
		Connection con=null; 
		PreparedStatement pstmt = null; 
		ResultSet rs = null; 
		try{ 
			con = DriverManager.getConnection( 
					"jdbc:oracle:thin:@localhost:1521:xe", 
					"system", 
					"1111"); 
			String sql = "create table syh1011(id varchar(10)," + 
					"password varchar(10))"; 
			pstmt = con.prepareStatement(sql); 
			int updateCount = pstmt.executeUpdate(); 
			System.out.println("createCount : " + updateCount); 

			sql = "insert into syh1011 values(?,?)"; 
			pstmt = con.prepareStatement(sql); 
			pstmt.setString(1,"syh2022"); 
			pstmt.setString(2,"1111");
			updateCount = pstmt.executeUpdate(); 
			System.out.println("inser tCount : " + updateCount); 

			sql = "select * from syh1011"; 
			pstmt = con.prepareStatement(sql); 
			rs = pstmt.executeQuery(); 
			while(rs.next()){ 
				System.out.print("id : "+rs.getString(1)); 
				System.out.println(", password : "+rs.getString(2)); 
			} 

			sql = "drop table syh1011"; 
			pstmt = con.prepareStatement(sql); 
			updateCount = pstmt.executeUpdate(); 
			System.out.println("dropCount : " + updateCount); 
		}catch(SQLException sqle){ 
			sqle.printStackTrace(); 
		}finally{ 
			try{ 
				if(rs != null) rs.close(); 
				if(pstmt != null) pstmt.close(); 
				if(con != null) con.close(); 
			}catch(SQLException sqle){} 
		} 
	} 
}
